# Copyright 1999-2012 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI="5"
PYTHON_COMPAT=( python{2_6,2_7} )

inherit distutils eutils

DESCRIPTION="Very fast JSON encoder/decoder for Python"
HOMEPAGE="http://pypi.python.org/pypi/python-cjson/
	http://ag-projects.com/"
SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
RESTRICT="primaryuri"

LICENSE="LGPL-2"
KEYWORDS="amd64 x86 arm"
IUSE="+test"
SLOT="0"

DEPEND="dev-python/setuptools"
RDEPEND="${DEPEND}"

src_prepare() {
	# fix for bug reported at http://garybernhardt.blogspot.com/2007/07/when-json-isnt-json.html
	# >>> cjson.decode(simplejson.dumps('/'))
	# '/'
	epatch "${FILESDIR}/python-cjson-1.0.5.diff"
}

src_test() {
	testing() {
		PYTHONPATH="$(ls -d build-${PYTHON_ABI}/lib.*)" "$(PYTHON)" jsontest.py
	}
	python_execute_function testing
}
