# Copyright 1999-2014 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: 

EAPI=5

PYTHON_COMPAT=( python2_7 )

#if LIVE
inherit mercurial
EHG_REPO_URI="https://bitbucket.org/nocproject/noc"
EHG_REVISION="develop"
#EHG_PROJECT="${PN}"
#endif

inherit apache-module distutils-r1 eutils pax-utils user

DESCRIPTION="NOC is an Operation Support System (OSS) and Enterprise Network Operation Centers (NOC)."
HOMEPAGE="http://nocproject.org/"

### NOC is very-very sensitive to dependency version!
### If you have strange problem with NOC installation please look in
### noc/etc/requirements
### cat etc/requirements/*.txt |sort |uniq |grep noc-pkg
SRC_URI="https://cdn.nocproject.org/pkg/noc-pkg-codemirror-4.6.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-extjs-5.1.0.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-famfamfam-silk-1.3.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-flot-0.8.3.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-font-awesome-4.2.0.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-grafana-1.9.1.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-handlebars-1.0.0.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-jquery-1.11.0.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-mxgraph-1.10.4.2.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-openlayers-2.13.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-silk-companion1-1.0.tar.gz
	https://cdn.nocproject.org/pkg/noc-pkg-stacktrace-1.0.0.tar.gz
	debug? ( https://cdn.nocproject.org/pkg/noc-pkg-extjs-debug-5.1.0.tar.gz
		https://cdn.nocproject.org/pkg/noc-pkg-handlebars-debug-1.0.0.tar.gz
		https://cdn.nocproject.org/pkg/noc-pkg-mxgraph-debug-1.10.4.2.tar.gz
		https://cdn.nocproject.org/pkg/noc-pkg-openlayers-debug-2.13.tar.gz
		https://cdn.nocproject.org/pkg/noc-pkg-shjs-debug-0.6.tar.gz )"

#       extensions? ( http://downloads.nocproject.org/files/staticvlan-0.7(4).tar.bz2 )"
# new   extensions? ( http://fs04n5.sendspace.com/dl/5c69be63bf33426bacaf1e81fe36abe8/4ff6ee2c6ac0a501/x1ofpm/staticvlan-0.7%284%29.tar.bz2 )"
#       extensions? ( http://forum.nocproject.org/index.php?action=dlattach;topic=31.0;attach=11 )"

LICENSE="BSD"
SLOT="0"
KEYWORDS="~amd64"
IUSE="-apache2 -debug hardened -lighttpd +nginx -ownmaps -extensions"

S=${WORKDIR}/${PN}

#if LIVE
KEYWORDS=
#endif

# General NOC dependency list from: noc/setup.cfg
### NOC is very-very sensitive to dependency version!
### If you have strange problem with NOC installation please look in
### noc/etc/requirements
### It is spatially impotent when you update NOC manually from CVS!!!
### Originally NOC installation use pip for setup dependency from noc/etc/requirements,
### but in Gentoo NOC use system packages!
### cat etc/requirements/*.txt |sort |uniq |grep -v noc-pkg
DEPEND="app-admin/pwgen
	>=dev-db/postgis-1.5
	~dev-libs/protobuf-2.5.0[python]
	>=dev-vcs/mercurial-2.5.2[gpg]
	>=dev-python/backports-ssl-match-hostname-3.4.0.2
	~dev-python/blinker-1.3
	~dev-python/cachetools-0.5.1
	~dev-python/coverage-3.7
	~dev-python/dbf-0.95.004
	~dev-python/db-sqlite3-0.0.1
	~dev-python/django-1.4.15[postgres]
	~dev-python/docutils-0.7
	~dev-python/ecdsa-0.11
	>=dev-python/futures-2.2
	~dev-python/geopy-0.97
	~dev-python/gmpy-1.16
	dev-python/lxml
	~dev-python/manhole-0.6.2
	~dev-python/mongoengine-0.8.7
	>=dev-python/netifaces-0.8
	>=dev-python/pip-1.5.6
	>=dev-python/psycopg-2.5
	~dev-python/pyasn1-0.1.7
	~dev-python/pyasn1-modules-0.0.5
	>=dev-python/pycrypto-2.6
	~dev-python/pygments-1.2.2
	~dev-python/pymongo-2.7.2
	~dev-python/pyparsing-2.0.2
	~dev-python/pysnmp-4.2.1
	>=dev-python/python-cjson-1.0.5
	~dev-python/python-creole-0.2.4
	~dev-python/python-dateutil-2.4.0
	>=dev-python/pytz-2014.4
	~dev-python/requests-2.2.1
	>=dev-python/setuptools-3.6
	>=dev-python/six-1.7.2
	~dev-python/sleekxmpp-1.1.11
	~dev-python/south-0.7.3
	~dev-python/vectorformats-0.1
	dev-python/virtualenv
	~dev-python/whoosh-2.5.4
	dev-util/quilt
	>=net-libs/libsmi-0.4.7
	~www-servers/tornado-4.0.2
	ownmaps? ( >=sci-geosciences/mapnik-2 sci-geosciences/osm2pgsql )
	extensions? ( media-gfx/graphviz )"

RDEPEND="${DEPEND}
	>=dev-db/mongodb-2.6
	>=dev-db/postgresql-9[server]
	net-analyzer/fping
	net-dns/bind-tools
	apache2? ( www-servers/apache www-apache/mod_fastcgi )
	lighttpd? ( www-servers/lighttpd )
	nginx? ( www-servers/nginx )"

PATCHES=(
	"${FILESDIR}/${PN}-0.9-gentoo.patch"
	"${FILESDIR}/${PN}-0.9-config.patch"
	"${FILESDIR}/${PN}-0.9-system_site_packages.patch"
)

pkg_pretend() {
	if use apache2; then
		if [[ $(echo ${APACHE2_MODULES} |grep 'proxy_http') == '' ]]; then
			einfo "Add following line to /etc/make.conf and rebuild apache !"
			einfo 'APACHE2_MODULES="${APACHE2_MODULES} proxy proxy_http"'
			die "REBUILD APACHE WITH 'proxy proxy_http' MODULES SUPPORT !"
		fi

#	       MODULE_CRITICAL="proxy proxy_http"
#	       check_module_critical || die "Rebuild apache with 'proxy proxy_http' modules support."

#	       if use !apache2_modules_proxy_http; then
#		       die "Rebuild apache with 'proxy proxy_http' support."
#	       fi
	fi
}

src_install() {
	distutils-r1_src_install

	# Install hg repo
	cp -r "${S}"/.hg "${D}"/opt/noc/

	if use extensions; then
		cp -r "${WORKDIR}/staticvlan" "${D}"/opt/noc/ || die "Download staticvlan-${PV} manually: http://forum.nocproject.org/index.php?action=dlattach;topic=31.0"
		dodoc ${WORKDIR}/staticvlan/README-STATIC_VLAN
	fi

	doinitd "${FILESDIR}/${PN}"
}

pkg_postinst() {
	distutils-r1_pkg_postinst

	virtualenv --system-site-packages /opt/noc/
	cd /opt/noc
	ln -s /usr/bin/hg ./bin/hg
	if use hardened; then
		pax-mark Em ./bin/python2.7
	fi

	cp ./etc/upgrade.defaults ./etc/upgrade.conf
	chown root:root ./etc/upgrade.conf
	chmod 600 ./etc/upgrade.conf

	elog ""
	elog "For automatic NOC configuration look in: /opt/noc/etc/upgrade.conf"
	elog "Then run:"
	elog " # emerge --config net-analyzer/noc"
	elog ""

	if use apache2; then
		cp ${FILESDIR}/01_noc_vhost.conf /etc/apache2/vhosts.d/
		mv /etc/apache2/vhosts.d/00_default_ssl_vhost.conf /etc/apache2/vhosts.d/00_default_ssl_vhost.conf.old
		sed -i 's/need net postgresql mongodb/need net postgresql mongodb apache2/' /etc/init.d/noc
		elog ""
		elog "For apache virtual host configuration take a look in: /etc/apache2/vhosts.d/01_noc_vhost.conf"
		elog "Edit /etc/apache2/httpd.conf file:"
		elog "#<IfDefine PROXY>"
		elog "LoadModule proxy_module modules/mod_proxy.so"
		elog "#</IfDefine>"
		elog "#<IfDefine PROXY>"
		elog "LoadModule proxy_http_module modules/mod_proxy_http.so"
		elog "#</IfDefine>"
		elog ""
		elog "Generate SSL certificate for apache server. Enter proper FQDN or 'localhost' if you don't know it:"
		elog " cd /etc/ssl/apache2"
		elog " openssl req -new -x509 -nodes -out server.crt -keyout server.key -days 1000"
		elog " openssl x509 -noout -text -in server.crt"
		elog ""
	fi
	if use nginx; then
		mv /etc/nginx/nginx.conf /etc/nginx/nginx.conf.old
		cp ${FILESDIR}/nginx.conf /etc/nginx/
		sed -i 's/need net postgresql mongodb/need net postgresql mongodb nginx/' /etc/init.d/noc
	fi
	if use lighttpd; then
		sed -i 's/need net postgresql mongodb/need net postgresql mongodb lighttpd/' /etc/init.d/noc
	fi

	elog "For manual configuration reed next... (you don't need it if you run 'emerge --config net-analyzer/noc')"
	elog ""
	elog ""
	elog "Create system noc_group and noc_user:"
	elog " # groupadd noc"
	elog " # useradd -g noc -s /bin/bash -d /opt/noc noc"
	elog "Write it in /opt/noc/etc/upgrade.conf"
	elog ""
	elog "Configure PostgreSQL server if you run it first time, like this:"
	elog "Check /etc/conf.d/postgresql-9.3"
	elog " # emerge --config dev-db/postgresql-server"
	elog "Run PostgreSQL server:"
	elog " # /etc/init.d/postgresql-9.3 start"
	elog ""
	elog "Next steps is described here, start read from 'Create PostgreSQL database' section:"
	elog "http://kb.nocproject.org/display/DOC/Manual+Installation"
	elog ""
	elog "Create database user noc from PostgreSQL superuser (postgres in example):"
	elog " # su - postgres"
	elog " postgres@/$ psql"
	elog " postgres=# CREATE USER noc SUPERUSER ENCRYPTED PASSWORD '<password>';"
	elog ""
	elog "Then create database noc owned by user noc:"
	elog " postgres=# CREATE DATABASE noc ENCODING 'UTF8' OWNER noc;"
	elog " postgres=# \q"
	elog ""
	elog "Change configuration files"
	elog " # cp /opt/noc/etc/upgrade.defaults /opt/noc/etc/upgrade.conf"
	elog "Set up etc/upgrade.conf: 'PostgreSQL database connection' section."
	elog ""
	elog "Run MongoDB server:"
	elog " # /etc/init.d/mongodb start"
	elog ""
	elog "Set MongoDB password"
	elog " # mongo --shell"
	elog " MogoDB shell version: 2.6.5"
	elog " connecting to: test"
	elog " > use noc"
	elog " switched to db noc"
	elog ' > db.createUser({ user: "noc", pwd: "xxxxxxxxxx", roles: [ "readWrite", "dbAdmin" ] })'
	elog " > quit()"
	elog "Set up etc/upgrade.conf: 'Mongodb database connection' section."
	elog ""
	elog "Edit /opt/noc/etc/upgrade.conf to your local requirements and set 'ENABLED=yes'."
	elog ""
	elog " # ./scripts/upgrade"
	elog ""
	elog "Drop user noc privilage:"
	elog " # psql -h 127.0.0.1 -d noc -U postgres"
	elog " # ALTER USER noc NOSUPERUSER;"
	elog " # \q"
	elog ""
	elog "It is user in NOC with administrative privilege: admin"
	elog "To change password run:"
	elog " # cd /opt/noc"
	elog " # ./noc changepassword admin"
	if use extensions; then
		elog ""
		elog "Read doc in /opt/noc/README-STATICVLAN"
		elog "now change /opt/noc/etc/noc.conf to use staticvlan module:"
		elog "installed_apps = staticvlan"
		elog "other configuration do after running NOC"
	fi
	elog ""
	elog "Edit activator conf file: /opt/noc/etc/noc-activator.conf"
	elog "name = default"
	elog "secret = secret"
	elog ""
	elog "Start NOC:"
	elog " # /etc/init.d/noc start"
	elog "Go to 'https://127.0.0.1/' accept certificate and enable java scripts."
	elog "Service Activation > Setup > Activators "
	elog "and create activator with same 'Name:' and 'Auth String:'"
	elog "as you enter in /opt/noc/etc/noc-activator.conf"
	elog "Restart NOC:"
	elog " # /etc/init.d/noc restart"
	elog ""
	elog "Add one or more Managed Object (Service Activation > Managed Objects)"
	elog "You will get your network database initialized and device configuration grabbed in 5-15 minutes"
	if use ownmaps; then
		elog ""
		elog "For creating map read:"
		elog "http://kb.nocproject.org/pages/viewpage.action?pageId=2687475"
	fi
	elog ""
	elog "Edit up /opt/noc/etc/noc-notifier.conf and set up SMTP server, address, user and password for outgoing mail"
	elog "Restart NOC:"
	elog " # /etc/init.d/noc restart"
	elog "In web interface, go to Main > Setup > Notification Groups, create notification group and set email"
	elog "In Main > Setup > System Notifications assign newly created notification group to all system events"
	elog "Other documantation:"
	elog "http://kb.nocproject.org/display/DOC/Home"
}

pkg_postrm() {
	distutils-r1_pkg_postrm
}

pkg_config() {
	ebegin "Checking PostreSQL server"
	if [ -z "$(/etc/init.d/postgresql-* -C status |grep started)" ] ; then
		eend 1
		ewarn "Configure PostgreSQL server if you run it first time, like this:"
		ewarn "Check /etc/conf.d/postgresql-9.3"
		ewarn " # emerge --config dev-db/postgresql-server"
		ewarn "Then run PostgreSQL server:"
		ewarn " # /etc/init.d/postgresql-9.3 start"
		die "Run PostgreSQL server!"
	else
		eend 0
	fi

	ebegin "Checking MongoDB server"
	if [ -z "$(/etc/init.d/mongodb -C status |grep started)" ] ; then
		eend 1
		ewarn "Check /etc/mongodb.conf"
		ewarn "Run MongoDB server:"
		ewarn " # /etc/init.d/mongodb start"
		die "Run MongoDB server!"
	else
		eend 0
	fi

	cd /opt/noc
	[ -f ./etc/upgrade.defaults ] && . ./etc/upgrade.defaults
	. ./etc/upgrade.conf || die "Can't find configfile: /opt/noc/etc/upgrade.conf Create it from /opt/noc/etc/upgrade.defaults"

	groupadd -f "${NOC_GROUP}"
	useradd -g "${NOC_GROUP}" -s /bin/bash -M -d /opt/noc "${NOC_USER}"
	touch .bash_history
	chown -R "${NOC_USER}":"${NOC_GROUP}" .bash_history
	chmod 600 .bash_history

	if use extensions; then
		chown -R "${NOC_USER}":"${NOC_GROUP}" static/staticvlan
	fi

	einfo "Create PostgreSQL 'noc' user and database..."
	if [ "${PG_PASSWORD}" == "noc" ] ; then
		PG_PASSWORD="$(pwgen -s1 16)"
		sed -i "s/PG_PASSWORD=noc/PG_PASSWORD=${PG_PASSWORD}/" etc/upgrade.conf
	fi
	su - postgres -c 'psql -c "CREATE USER '${PG_USER}' SUPERUSER ENCRYPTED PASSWORD '"'${PG_PASSWORD}'"';"' || die "Failed create user"
	su - postgres -c 'psql -c "CREATE DATABASE '${PG_DB}' ENCODING '"'UTF8' OWNER ${PG_USER};"'"' || die "Failed create DB"

	einfo "Setting MongoDB authentication..."
	if [ ${MONGO_PASSWORD} == "noc" ] ; then
		MONGO_PASSWORD="$(pwgen -s1 16)"
		sed -i "s/MONGO_PASSWORD=noc/MONGO_PASSWORD=${MONGO_PASSWORD}/" etc/upgrade.conf
	fi
	mongo --shell << __EOF__
use ${MONGO_DB}
db.createUser({ user: "${MONGO_USER}", pwd: "${MONGO_PASSWORD}", roles: [ "readWrite", "dbAdmin" ] })
__EOF__
[[ $? -eq 0 ]] || die "Failed to initialize MongoDB database and user"

	einfo ""
	einfo "Running NOC's setups..."
	sed -i 's/ENABLED=no/ENABLED=yes/' ./etc/upgrade.conf
	sed -i 's/BRANCH=default/BRANCH=develop/' etc/upgrade.conf
	for i in $(ls ./etc/*.defaults); do sed -i 's/logfiles = 0/logfiles = 9/' $i; done
	for i in $(ls ./etc/*.defaults); do sed -i 's/logsize  = 0/logsize =  2000000/' $i; done
	# BUG FIX BEGIN
	sed -i 's/db-sqlite3==0.0.1//' ./etc/requirements/common.txt
	# BUG FIX END
	./scripts/upgrade || die "NOC script './scripts/upgrade' failed!!!"
	su - postgres -c "psql -c 'ALTER USER ${PG_USER} NOSUPERUSER;'" || die "Failed drop noc user privilege"
	pass="$(pwgen -sy1 50)"
	./scripts/set-conf.py etc/noc.conf main secret_key "${pass}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-web user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-scheduler user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-sae user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-classifier user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-correlator user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-notifier user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-probe user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-discovery user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-sync user "${NOC_USER}"
	./scripts/set-conf.py etc/noc-launcher.conf noc-pmwriter user "${NOC_USER}"
	einfo ""
	einfo "Configuring NOC's activator..."
	einfo "Input name of network devise with acces to you commutators/routers (example: eth0)..."
	read dev
	pass="$(pwgen -s1 16)"
	cd /opt/noc
	./scripts/set-conf.py etc/noc-launcher.conf noc-activator user root
	./scripts/set-conf.py etc/noc-activator.conf activator listen_traps ${dev}
	./scripts/set-conf.py etc/noc-activator.conf activator listen_syslog ${dev}
	./scripts/set-conf.py etc/noc-activator.conf activator name default
	./scripts/set-conf.py etc/noc-activator.conf activator secret "${pass}"
	pg_comands='"BEGIN;UPDATE sa_activator SET auth='"'${pass}'"';COMMIT;"'
	su - postgres -c "psql -d ${PG_DB} -c ${pg_comands}" || die "Failed to configure NOC's activator..."

	elog ""
	ewarn "Input NOC web login password for user 'admin'"
	cd /opt/noc
	./noc changepassword admin
	elog ""
	elog "To change password run as noc user:"
	elog " $ cd /opt/noc"
	elog " $ ./noc changepassword admin"
	elog "Or use web interface: Main -> Setup -> Users"

	elog ""
	elog "Now you can start NOC:"
	elog " # /etc/init.d/noc start"
	ewarn "Go in you web browser to 'https://127.0.0.1' accept certificate and enable java scripts."
	elog "You may edit web server configuration file for listening other interface..."
	elog ""
	elog "If some go worong, spetialy in 'Running NOC's setups...' phase, try:"
	elog " # /etc/init.d/noc stop"
	elog " # /etc/init.d/mongodb restart"
	elog " # /etc/init.d/postgresql-9.3 restart"
	elog " # cd /opt/noc"
	elog " # ./scripts/upgrade"
	elog "If you see python trace during running './scripts/upgrade' run it again..."
	elog " # ./scripts/upgrade"
	elog " # /etc/init.d/noc start"

	elog ""
	elog "Add one or more Managed Object (Service Activation > Managed Objects)"
	elog "You will get your network database initialized and device configuration grabbed in 5-15 minutes"
	elog ""
	elog "Edit up /opt/noc/etc/noc-notifier.conf and set up SMTP server, address, user and password for outgoing mail"
	elog "Restart NOC:"
	elog " # /etc/init.d/noc restart"
	elog "In web interface, go to Main > Setup > Notification Groups, create notification group and set email"
	elog "In Main > Setup > System Notifications assign newly created notification group to all system events"
	elog ""
	elog "Other documentation: http://kb.nocproject.org/display/DOC/Home"
}
